#!/usr/bin/perl -w -I.
use strict;

#  ----------------------------------------------------------------------
# | Computer Science Teaching Center                                     |
# | Hussein Suleman                                                      |
# | April 2001                                                           |
#  ----------------------------------------------------------------------
# |  Virginia Polytechnic Institute and State University                 |
# |  Department of Computer Science                                      |
# |  Digital Library Research Laboratory                                 |
#  ----------------------------------------------------------------------

package Ext::XSLT;


use POSIX;


sub new
{
   my ($classname, $xsltfile) = @_;
   my $self = {
      xsltfile    => $xsltfile
   };

   bless $self, $classname;

   return $self;
}

# apply xsl to string

sub Transform
{
   my ($self, $xmlstring, @paramlist) = @_;
   
   $xmlstring =~ s/&/&amp;/go;

   my $filename = tmpnam ();
   
   open (FILE, ">$filename");
   print FILE $xmlstring;
   close (FILE);
   
   my $params = '';
   foreach my $param (@paramlist)
   {
      $params .= "--param $param->[0] \"\\\"$param->[1]\\\"\" ";
   }

   open (FILE, "xsltproc $params $self->{xsltfile} $filename |");
   my @data = <FILE>;
   close (FILE);
   
   shift @data;
   
   unlink $filename;
   
   my $outputdata = join ('', @data);
   $outputdata =~ s/&amp;/&/go;
   return $outputdata;
}

1;
